USE ANSHU 
GO
--SELECT * FROM ATTENDENCE WHERE ID!=0
--SELECT * FROM ATTENDENCE WHERE ID=0
--UPDATE ATTENDENCE SET DESIGNATION='MECHANICAL ENGG. | SUPERVISOR' WHERE TRIM(NAME)='Ranjay Kumar' AND DESIGNATION  IS NULL
--SELECT B.* FROM MA_User A JOIN ATTENDENCE B ON TRIM(A.NAME)=TRIM(B.NAME) AND TRIM(A.DESIGNATION)=TRIM(B.DESIGNATION)
--SELECT NAME,DESIGNATION,COUNT(*) FROM ATTENDENCE GROUP BY NAME,DESIGNATION
--HAVING COUNT(*)>1
--SELECT A.ID,B.ID FROM ATTENDENCE A JOIN MA_User B ON TRIM(A.NAME)=TRIM(B.NAME) AND TRIM(A.DESIGNATION)=TRIM(B.DESIGNATION)

USE ANSHU
GO
 DECLARE @MONTH_YEAR VARCHAR(50)='2020-06-'
 DECLARE @MONTH VARCHAR(50)='Jun 2020'
 DECLARE @TEMP_TABLE VARCHAR(50)=UPPER( CONCAT('TEMP_ATTENDENCE_',REPLACE(@MONTH,' ','_')))
 

UPDATE ATTENDENCE SET ID=B.ID FROM ATTENDENCE A JOIN MA_User B ON TRIM(A.NAME)=TRIM(B.NAME) AND TRIM(A.DESIGNATION)=TRIM(B.DESIGNATION)

 INSERT INTO UserAttendence (UserId,IsPresent,Date,Location,Remarks,LeaveId,IsApproved,Month_Year,Value)
 SELECT DISTINCT
 ID 
 ,CASE WHEN [Value] IN('P') THEN 1 ELSE 0 END AS IsPresent
 ,CONVERT(DATE,CONCAT(@MONTH_YEAR,REPLACE(DAYSS,'_',''))) AS DATES
 ,'ADMIN OFFICE' AS Location
 ,NULL AS REMARKS
 ,CASE WHEN [Value] IN('P') THEN NULL
       WHEN [Value] IN('A') THEN (SELECT TOP 1 ID FROM MA_Leave WHERE Name='ABSENT')
	   WHEN [Value] IN('L') THEN (SELECT TOP 1 ID FROM MA_Leave WHERE Name='LEAVE')
	   WHEN [Value] IN('H') THEN (SELECT TOP 1 ID FROM MA_Leave WHERE CONVERT(DATE,FROMDATE)=CONVERT(DATE,CONCAT(@MONTH_YEAR,REPLACE(DAYSS,'_',''))) )
	   ELSE NULL END AS LEAVEID
 ,1 AS IsApproved
 ,@MONTH AS Month_Year
 ,[Value]
 
 FROM (
SELECT 
	ID
	,NAME
	,DESIGNATION
	,DAYSS
	,[Value] 
FROM   
   ATTENDENCE  AS P  
UNPIVOT  
   ([Value] FOR DAYSS IN 
(
 _1
,_2
,_3
,_4
,_5
,_6
,_7
,_8
,_9
,_10
,_11
,_12
,_13
,_14
,_15
,_16
,_17
,_18
,_19
,_20
,_21
,_22
,_23
,_24
,_25
,_26
,_27
,_28
,_29
,_30
--,_31
)  
)AS UNPVT WHERE ID!=0  
)A


EXEC ('SELECT * INTO '+@TEMP_TABLE+' FROM ATTENDENCE')
GO
DROP TABLE ATTENDENCE
 